/*v 1.11
      
      
    ZENER Test 
         
         
    
     -       
           ""     
  ""      "" 
      "" 
*/

        unsigned char BPORT;


        unsigned char MODE;         //  000 -  , 001 -  
        unsigned char COND;  // 

        unsigned char R2_5,R2_6,R2_7,R2_8,R2_9,R2_10,R2_11,R2_12,R2_13,R2_14,R2_15,R2_16;
        unsigned char R3_5,R3_6,R3_7,R3_8,R3_9,R3_10,R3_11,R3_12,R3_13,R3_14,R3_15,R3_16;

        unsigned char VOLT10, VOLT1, VOLT01, VOLT001;      // 
        //unsigned char VOLT001;
        unsigned long int ADCRES;   //  

        unsigned char R4_9, R4_7;  //  4.9 (SETUP, READY)

        unsigned char DOT2_1, DOT3_1, DOT3_2, DOT2_2; // 

        sbit Int at COND.B7;            // = 1,   
        
        unsigned long int RES1, RES2, RES11, RES22;   //  
        
        unsigned char Ist;              //  
        unsigned long int DAC;          // ,   
        unsigned long int Word;         //32-   
        unsigned char n, n1;                // 
        
// Software I2C connections
sbit Soft_I2C_Scl           at RC3_bit;
sbit Soft_I2C_Sda           at RC4_bit;
sbit Soft_I2C_Scl_Direction at TRISC3_bit;
sbit Soft_I2C_Sda_Direction at TRISC4_bit;
// End Software I2C connections


void interrupt()
     {
// ****************************
     if (RBIF_bit)
        {Delay_ms(100);
        BPORT = PORTB;
        RBIF_bit = 0;
        if (!RB4_bit&&RB5_bit)             //  
           {Int = 1;
           Mode = 0x01;
           }
        if (!RB5_bit&&RB4_bit)             //   
           {Int = 1;
           Mode = 0x00;
           Ist = ++Ist;                    //  2 
           if (Ist > 4) Ist = 0;
           }
        }
     }



/* ******************************************************************************** */
/* *********************************  ***************************** */
/* ******************************************************************************** */

void Indicator_Write_Word1()                   //  1
     {Soft_I2C_Start();                            // Issue start signal 1
     Soft_I2C_Write(0x76);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x34);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x0C);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x06);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x35);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0xFF);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x99);                    //  -  9
                                                            //  9 
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x03);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x04);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x08);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x34);
     Soft_I2C_Stop();                               // Issue stop signal 1
     }

void Indicator_Write_Word2()                    //  2
     {Soft_I2C_Start();                              // Issue start signal 2
     Soft_I2C_Write(0x76);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x40);
     Soft_I2C_Write(R2_5);
     Soft_I2C_Write(R2_6);
     Soft_I2C_Write(R2_7);
     Soft_I2C_Write(R2_8);
     Soft_I2C_Write(R2_9);
     Soft_I2C_Write(R2_10);
     Soft_I2C_Write(R2_11);
     Soft_I2C_Write(R2_12);
     Soft_I2C_Write(R2_13);
     Soft_I2C_Write(R2_14);
     Soft_I2C_Write(R2_15);
     Soft_I2C_Write(R2_16);
     Soft_I2C_Stop();                               // Issue stop signal 2
     }



void Indicator_Write_Word3()                     //  3
     {Soft_I2C_Start();                              // Issue start signal 3
     Soft_I2C_Write(0x76);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0xC0);
     Soft_I2C_Write(0x40);
     Soft_I2C_Write(R3_5);
     Soft_I2C_Write(R3_6);
     Soft_I2C_Write(R3_7);
     Soft_I2C_Write(R3_8);
     Soft_I2C_Write(R3_9);
     Soft_I2C_Write(R3_10);
     Soft_I2C_Write(R3_11);
     Soft_I2C_Write(R3_12);
     Soft_I2C_Write(R3_13);
     Soft_I2C_Write(R3_14);
     Soft_I2C_Write(R3_15);
     Soft_I2C_Write(R3_16);
     Soft_I2C_Stop();                               // Issue stop signal 3
     }


void Indicator_Write_Word4()                     //  4
     {Soft_I2C_Start();                              // Issue start signal 4
     Soft_I2C_Write(0x76);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x40); //5
     Soft_I2C_Write(0x40);
     Soft_I2C_Write(R4_7);
     Soft_I2C_Write(0x00);
     Soft_I2C_Write(R4_9);
     Soft_I2C_Write(0x00); //10

     Soft_I2C_Write(DOT2_1|DOT2_2);
     Soft_I2C_Write(DOT3_1);
     Soft_I2C_Write(DOT3_2);
     Soft_I2C_Write(0x00);
     Soft_I2C_Stop();                               // Issue stop signal 4
     }

void Indicator_Write_Word5()                    //  5
     {Soft_I2C_Start();                              // Issue start signal 4
     Soft_I2C_Write(0x76);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x80);
     Soft_I2C_Write(0x40); //5
     Soft_I2C_Write(0x40);
     Soft_I2C_Write(R4_7);
     Soft_I2C_Write(0x00);
     Soft_I2C_Write(R4_9);
     Soft_I2C_Write(0x00); //10
     
     Soft_I2C_Write(DOT2_1|DOT2_2);
     Soft_I2C_Write(DOT3_1);
     Soft_I2C_Write(DOT3_2);
     Soft_I2C_Write(0x00);
     Soft_I2C_Stop();                               // Issue stop signal 5
     }
// ********************   *********************************


void Initialization()
{/*initialization of ports*/
     PORTC = 0x00;
     TRISC = 0x00;                               // 

     PORTA = 0xFF;
     TRISA = 0x2F;                               //0, 1 ,2, 3, 5 - 
     ADCON1 = 0x82;                              //  , AN0, AN1, AN2, AN3 -  , Vref = Vdd
     ADCON0 = 0x00;                              //F/2,  0,   
     
     ADCS2_bit = 1;                              // F/64
     ADCS1_bit = 1;
     ADCS0_bit = 0;
     
     OPTION_REG = 0x71;                          //pull-up resistors on
                                                 //TMR0 -    c RA4,  
                                                 //  TMR0  = 1:8
     PORTB = 0xF9;
     TRISB = 0xF9;                               // RB1, RB2 is outputs

     R4_7 = R4_9 = 0x00;
     Ist = 0;                                    //  1 
     DAC = 0x0A80A8;                             //      I = 1 

     ADON_bit = 1;    //  
     INTE_bit = 1;
     GIE_bit = 1;
}

void Test()   //     ZENER Test
{    R2_5 = 'Z';
     R2_6 = 'E';
     R2_7 = 'N';
     R2_8 = 'E';
     R2_9 = 'R';
     R2_10 = R2_11 = R2_12 = R2_13 = R2_14 = R2_15 = R2_16 = 0x20;
     R3_7 = 'T';
     R3_8 = 'e';
     R3_10 = 's';
     R3_11 = 't';
     R4_9 = 0x00;                          //  READY
     R3_5 = R3_6 = R3_9 = R3_15 = R3_16 = R3_12 = R3_13 = R3_14 = 0x20;
}


void Measure1()        // 
{     delay_ms(50);
      GO_bit = 1;
      while (GO_bit){}  //   
      ADCRES = (unsigned long int)ADRESH;
      ADCRES = ADCRES << 8;
      ADCRES = ADCRES&0x0000FF00;
      ADCRES = ADCRES + (unsigned long int)ADRESL; //     
      ADCRES = ADCRES*50100;    //
//      ADCRES = ADCRES/1023;     //       1:10
}

void Calculation()
{     VOLT10 = VOLT1 = VOLT01 = 0x00;
      while (ADCRES > 9999) {ADCRES = ADCRES - 10000; ++VOLT10;}
      while (ADCRES > 999) {ADCRES = ADCRES - 1000; ++VOLT1;}       //   
      while (ADCRES > 99) {ADCRES = ADCRES - 100; ++VOLT01;}
      VOLT001 = ADCRES/10;
}

void Write_Indicator()
{    Indicator_Write_Word1();
     Indicator_Write_Word2();
     Indicator_Write_Word3();
     Indicator_Write_Word4();
     Indicator_Write_Word5();
}

void CleanScreen()
{  DOT2_2 = 0x00; R3_9 = 0x20;
   DOT3_2 = 0x00; R3_15 = 0x20;
   DOT3_1 = 0x00;
   R2_5 = R2_6 = R2_7 = R2_8 = R2_9 = 0x20;
   R3_7 = R3_8 = R3_10 = R3_11 = 0x20;       // 
}

void DAC_Load()                            // 
{unsigned char n;
for (n = 0; n < 24; n++)
     {if ((Word&0x800000) == 0) RC1_bit = 0; else RC1_bit = 1;   //     
     RC2_bit = 1;
     RC2_bit = 0;
     Word = Word << 1;                                                  //    
     }
RC0_bit = 1;                                                         //    
RC0_bit = 0;
}

//******************************************************************************************************
void main()
{
  Initialization();
  
/*initialization I2C*/
      Soft_I2C_Init();
      delay_ms(300);  //!!!    100 
/* ******************************************************************************** */
   Test();            //     
   DOT2_1 = DOT3_1 = DOT3_2 = DOT2_2 = 0x00; // 1   2  3  
   Write_Indicator();
   delay_ms(2000);                           //   2 
   CleanScreen();
//   R2_5 = R2_6 = R2_7 = R2_8 = R2_9 = 0x20;
//   R3_7 = R3_8 = R3_10 = R3_11 = 0x20;       // 

   Word = DAC&0x000FFF;
   DAC_Load();                   //    
                                             //  B
   R2_10 = 'I';
   R2_11 = 's';
   R2_12 = 't';
   R2_13 = '=';
   R3_12 = '1';
   R3_13 = 'm';
   R3_14 = 'A';
   
/* ************************* *************************/
  while(1)
  {Write_Indicator();
  
  Int = 0;                                    // 
  RBIF_bit = 0;
  RBIE_bit = 1;

  while (!Int){}
  RBIE_bit = 0;                               // 
  
  if (Mode == 0x00)                           //  
     {RB1_bit = 0;                            //  (  )
     RB2_bit = 0;
     R2_16 = 0x20;
     switch(Ist){//   
            case 0: R3_12 = 0x31;  DAC = 0x0A80A8; break;                 //1mA
            case 1: R3_12 = 0x32;  DAC = 0x14F14F; break;                 //2mA
            case 2: R3_12 = 0x35;  DAC = 0x347347; break;                 //5mA
            case 3: R2_16 = 0x31; R3_12 = 0x30; DAC = 0x68E68E;  break;   //10mA
            case 4: R2_16 = 0x32; R3_12 = 0x30; DAC = 0xD1CD1C;           //20mA
            }
     CleanScreen();                                         // 
//     DAC_Load(DAC);                                       //     
     }
  
  if (Mode == 0x01)                              //  
     {//if (RC5_bit) RC5_bit = 0; else RC5_bit = 1; //////////////////////////////////////////////
     R4_7 = 0x10;                               // MEAS      
     R4_9 = 0x00;                                // READY
     Write_Indicator();
//     DAC_Load(DAC&0xFFF000);                     //  A    
                                                 //  
     //delay_ms(300);

     PORTB = PORTB|0x06;                         //      
//     delay_ms(100);
     
     Word = DAC&0x000FFF;
//     Word = DAC&0x000000;                        // *****************************************
     DAC_Load();                     //  B    
                                                 // A 
     delay_ms(100);
     RB2_bit = 0;                                // "" ,  "" 
//     delay_ms(100);
     CHS0_bit = 0; CHS1_bit = 0; CHS2_bit = 0;   //   0
     delay_ms(100);                              //  
     
     RES1 = 0;
     for (n1 = 0; n1 < 8; n1++)
     {Measure1();                                 //1-  
     RES1 = ADCRES + RES1;
     }
     RES1 = RES1 >> 3;
  
     CHS2_bit = 1;                               //   4
     delay_ms(100);                              //  
     
     RES11 = 0;
     for (n1 = 0; n1 < 8; n1++)
     {Measure1();                                 //2-  
     RES11 = ADCRES + RES11;
     }
     RES11 = RES11 >> 3;
  
     RES1 = (RES1 - RES11)/1023;                       //  1 RES1   ( ) ADCRES
     ADCRES = RES1;
     
     if (!RB3_bit) delay_ms(5000);
     
     RB2_bit = 1;                                // "" 
//     delay_ms(100);
//     DAC_Load(DAC&0x000FFF);                     //  B    
                                                 // A 
//     delay_ms(100);
     
     if (RES1 < 50000)
        {Calculation();                          //      
        R3_6 = R3_7 = 0x20;
//        R3_15 = 0x20;
        if (VOLT10 == 0) R3_8 = 0x20; else R3_8 = VOLT10 + 0x30;
        R3_10 = VOLT1 + 0x30;
        R3_11 = VOLT01 + 0x30;
        R3_9 = VOLT001 + 0x30;
//       R3_9 = 'v';
       R3_15 = 'v';
       R3_16 = '-';
       DOT3_1 = 0x01;
       }
       else {R3_7 = R3_8 = R3_10 = R3_11 = R3_9 = '-';
            DOT3_1 = 0x00;
            }
     R3_5 = '+';
     R3_16 = '-';

     Word = DAC&0xFFF000;
     //Word = DAC&0x000000;                             // *********************************
     DAC_Load();                     //  A    
                                                 // B 
     delay_ms(100);

     RB1_bit = 0;                                // "" ,  "" 
//     delay_ms(100);
     CHS0_bit = 0; CHS1_bit = 0; CHS2_bit = 0;   //   0
     delay_ms(100);                               //  
     
     RES2 = 0;
     for (n1 = 0; n1 < 8; n1++)
     {Measure1();                                 //1-  
     RES2 = ADCRES + RES2;
     }
     RES2 = RES2 >> 3;
     
     CHS2_bit = 1;                               //   4
     delay_ms(100);                                //  
     
     RES22 = 0;
     for (n1 = 0; n1 < 8; n1++)
     {Measure1();
     RES22 = RES22 + ADCRES;
     }
     RES22 = RES22 >> 3;
  
     RES2 = (RES22 - RES2)/1023;                       //  2 ADCRES   ( ) RES1
     ADCRES = RES2;
     
     if (!RB3_bit) delay_ms(5000);
     
     //ADCRES = RES11;                             // ******************************
     
     RB2_bit = 0;
     RB2_bit = 0;                                // 
//     delay_ms(100);
  
     if (RES2 < 50000)
        {Calculation();                              //      
        if (VOLT10 == 0) R2_5 = 0x20; else R2_5 = VOLT10 + 0x30;
        R2_6 = VOLT1 + 0x30;
        R2_7 = VOLT01 + 0x30;
       R2_8 = VOLT001 + 0x30;
//       R2_8 = 'v';
//       R2_9 = 0x20;
       R2_9 = 'v';
       DOT2_2 = 0x08;
       }
       else {R2_5 = R2_6 = R2_7 = R2_8 = R2_9 = '-';
            DOT2_2 = 0x00;
            }
     R4_7 = 0x00;                                // MEAS
     R4_9 = 0x10;                                // READY
     }
  }
}